#include "engine_loop.h"
#include "resources.h"
#include "render.h"
#include "stdlib.h"
#include "raylib.h"

static
void InitializeRaylibContext() {
    // initialize fullscreen game window
    SetConfigFlags(FLAG_VSYNC_HINT | FLAG_WINDOW_HIGHDPI);
    InitWindow(1280, 800, "Hello Raylib");
    if(!IsWindowFullscreen())
        ToggleFullscreen();
}

void RunGame() {
    while (!WindowShouldClose()) {
        RenderNextFrame();
    }
    ShutDown();
}

void InitializeEngine() {
    // initialize context
    InitializeRaylibContext();
    // initialize engine subsystems
    InitializeResourceSubsystem();
    InitializeRenderingSubsystem();
}

void ShutDown() {
    CleanResourceSubsystem();
    CloseWindow();
    exit(0);
}
